﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Default" %>

<!DOCTYPE html >
<html xmlns='http://www.w3.org/1999/xhtml'>
<head runat="server">
    <title>Highlight matching text in filtered items of RadAutoCompleteBox</title>
</head>

<body>
    <form id="form1" runat="server">
        <telerik:RadScriptManager runat="server" ID="RadScriptManager1" />
        <script>
            var $ = $telerik.$;

            function highlightDropDownItems(autocompletebox) {
                // https://stackoverflow.com/a/3294644
                autocompletebox._dropDown._items.forEach(function myfunction(item) {
                    var regex = new RegExp(autocompletebox.get_text(), 'gi')
                    var response = item._element.textContent.replace(regex, function (str) {
                        // modify the enclosing html of the text
                        return "<strong>" + str + "</strong>"
                    });

                    $(item._element).html(response);
                });
            }

            // Used when EnableClientFiltering="false"
            var original_populateDropDownFunction = Telerik.Web.UI.RadAutoCompleteBox.prototype._populateDropDown;
            function new_populateDropDownFunction(data, itemsRendered, renderShowAllButton, dataFields) {
                original_populateDropDownFunction.call(this, data, itemsRendered, renderShowAllButton, dataFields);
                highlightDropDownItems(this);
            }

            // Used when EnableClientFiltering="true"
            var originalOpenFunction = Telerik.Web.UI.RadAutoCompleteBox.DropDown.prototype.open;
            function newOpenFunction(positionInfo) {
                originalOpenFunction.call(this, positionInfo);

                var autocompletebox = this._dropDown.get_anchor().control;
                highlightDropDownItems(autocompletebox);
            }

            function OnClientLoad(sender, args) {
                if (sender.get_enableClientFiltering()) {
                    Telerik.Web.UI.RadAutoCompleteBox.DropDown.prototype.open = newOpenFunction;
                } else {
                    Telerik.Web.UI.RadAutoCompleteBox.prototype._populateDropDown = new_populateDropDownFunction;
                }
            }
        </script>

        <telerik:RadAutoCompleteBox RenderMode="Lightweight" runat="server" ID="RadAutoCompleteBox2"
            EmptyMessage="Please type here"
            DataTextField="ShipName"
            DataValueField="OrderID"
            OnClientLoad="OnClientLoad"
            InputType="Token"
            EnableClientFiltering="true">
        </telerik:RadAutoCompleteBox>
    </form>
</body>
</html>
